def strang_splitting_step(Phi_a, Phi_b, y0, dt):
    y_a = Phi_a(y0, 0.5*dt)
    y_ba = Phi_b(y_a, dt)
    y_aba = Phi_a(y_ba, 0.5*dt)
    return y_aba
    
def integrate(Phi_a, Phi_b, y0, t_end, n_steps):
    t, dt = np.linspace(0, t_end, n_steps+1, retstep=True)
    y = []
    y.append(y0)
    for i in range(n_steps):
        y.append(strang_splitting_step(Phi_a, Phi_b, 
                                       y[-1], dt))

    return t, np.asarray(y)
